searchNodes=[{"doc":"Converts an ecto changeset into a list of validation errors structs. Currently does not support nested errors","ref":"AbsintheErrorPayload.ChangesetParser.html","title":"AbsintheErrorPayload.ChangesetParser","type":"module"},{"doc":"Generate a single AbsintheErrorPayload.ValidationMessage struct from a changeset. This method is designed to be used with Ecto.Changeset.traverse_errors to generate a map of structs. ## Examples ``` error_map = Changeset.traverse_errors(fn(changeset, field, error) -&gt; AbsintheErrorPayload.ChangesetParser.construct_message(field, error) end) error_list = Enum.flat_map(error_map, fn({_, messages}) -&gt; messages end) ```","ref":"AbsintheErrorPayload.ChangesetParser.html#construct_message/2","title":"AbsintheErrorPayload.ChangesetParser.construct_message/2","type":"function"},{"doc":"Generate a list of AbsintheErrorPayload.ValidationMessage structs from changeset errors For examples, please see the test cases in the github repo.","ref":"AbsintheErrorPayload.ChangesetParser.html#extract_messages/1","title":"AbsintheErrorPayload.ChangesetParser.extract_messages/1","type":"function"},{"doc":"Inserts message variables into message. Code inspired by Phoenix DataCase.on_errors/1 boilerplate. Examples iex&gt; interpolate_message({&quot;length should be between %{one} and %{two}&quot;, %{one: &quot;1&quot;, two: &quot;2&quot;, three: &quot;3&quot;}}) &quot;length should be between 1 and 2&quot; iex&gt; interpolate_message({&quot;is already taken: %{fields}&quot;, %{fields: [:one, :two]}}) &quot;is already taken: one,two&quot;","ref":"AbsintheErrorPayload.ChangesetParser.html#interpolate_message/1","title":"AbsintheErrorPayload.ChangesetParser.interpolate_message/1","type":"function"},{"doc":"Generate unique code for each validation type. Expects an array of validation options such as those supplied by Ecto.Changeset.traverse_errors/2, with the addition of a message key containing the message string. Messages are required for several validation types to be identified. Supported :cast - generated by Ecto.Changeset.cast/3 :association - generated by Ecto.Changeset.assoc_constraint/3, Ecto.Changeset.cast_assoc/3, Ecto.Changeset.put_assoc/3, Ecto.Changeset.cast_embed/3, Ecto.Changeset.put_embed/3 :acceptance - generated by Ecto.Changeset.validate_acceptance/3 :confirmation - generated by Ecto.Changeset.validate_confirmation/3 :length - generated by Ecto.Changeset.validate_length/3 when the :is option fails validation :min - generated by Ecto.Changeset.validate_length/3 when the :min option fails validation :max - generated by Ecto.Changeset.validate_length/3 when the :max option fails validation :less_than_or_equal_to - generated by Ecto.Changeset.validate_length/3 when the :less_than_or_equal_to option fails validation :less_than - generated by Ecto.Changeset.validate_length/3 when the :less_than option fails validation :greater_than_or_equal_to - generated by Ecto.Changeset.validate_length/3 when the :greater_than_or_equal_to option fails validation :greater_than - generated by Ecto.Changeset.validate_length/3 when the :greater_than option fails validation :equal_to - generated by Ecto.Changeset.validate_length/3 when the :equal_to option fails validation :exclusion - generated by Ecto.Changeset.validate_exclusion/4 :inclusion - generated by Ecto.Changeset.validate_inclusion/4 :required - generated by Ecto.Changeset.validate_required/3 :subset - generated by Ecto.Changeset.validate_subset/4 :unique - generated by Ecto.Changeset.unique_constraint/3 :foreign - generated by Ecto.Changeset.foreign_key_constraint/3 :no_assoc_constraint - generated by Ecto.Changeset.no_assoc_constraint/3 :unknown - supplied when validation cannot be matched. This will also match any custom errors added through Ecto.Changeset.add_error/4, Ecto.Changeset.validate_change/3, and Ecto.Changeset.validate_change/4","ref":"AbsintheErrorPayload.ChangesetParser.html#to_code/1","title":"AbsintheErrorPayload.ChangesetParser.to_code/1","type":"function"},{"doc":"","ref":"AbsintheErrorPayload.FieldConstructor.html","title":"AbsintheErrorPayload.FieldConstructor","type":"behaviour"},{"doc":"","ref":"AbsintheErrorPayload.FieldConstructor.html#error/3","title":"AbsintheErrorPayload.FieldConstructor.error/3","type":"function"},{"doc":"","ref":"AbsintheErrorPayload.FieldConstructor.html#c:error/3","title":"AbsintheErrorPayload.FieldConstructor.error/3","type":"callback"},{"doc":"Absinthe Middleware to build a mutation payload response. AbsintheErrorPayload mutation responses (aka &quot;payloads&quot;) have three fields successful - Indicates if the mutation completed successfully or not. Boolean. messages - a list of validation errors. Always empty on success result - the data object that was created/updated/deleted on success. Always nil when unsuccesful Usage In your schema file import AbsintheErrorPayload.Payload import_types AbsintheErrorPayload.ValidationMessageTypes create a payload object for each object using payload_object(payload_name, object_name) create a mutation that returns the payload object. Add the payload middleware after the resolver. field :create_user, type: :user_payload, description: &quot;add a user&quot; do arg :user, :create_user_params resolve &amp;UserResolver.create/2 middleware &amp;build_payload/2 end Example Schema Object Schema: defmodule MyApp.Schema.User do @moduledoc false use Absinthe.Schema.Notation import AbsintheErrorPayload.Payload import_types AbsintheErrorPayload.ValidationMessageTypes alias MyApp.Resolvers.User, as: UserResolver object :user, description: &quot;Someone on our planet&quot; do field :id, non_null(:id), description: &quot;unique identifier&quot; field :first_name, non_null(:string), description: &quot;User&#39;s first name&quot; field :last_name, :string, description: &quot;Optional Last Name&quot; field :age, :integer, description: &quot;Age in Earth years&quot; field :inserted_at, :time, description: &quot;Created at&quot; field :updated_at, :time, description: &quot;Last updated at&quot; end input_object :create_user_params, description: &quot;create a user&quot; do field :first_name, non_null(:string), description: &quot;Required first name&quot; field :last_name, :string, description: &quot;Optional last name&quot; field :age, :integer, description: &quot;Age in Earth years&quot; end payload_object(:user_payload, :user) object :user_mutations do field :create_user, type: :user_payload, description: &quot;Create a new user&quot; do arg :user, :create_user_params resolve &amp;UserResolver.create/2 middleware &amp;build_payload/2 end end In your main schema file import_types MyApp.Schema.User mutation do ... import_fields :user_mutations end Alternate Use If you&#39;d prefer not to use the middleware style, you can generate AbsintheErrorPayload payloads in your resolver instead. See success_payload/1 and error_payload/1 for examples.","ref":"AbsintheErrorPayload.Payload.html","title":"AbsintheErrorPayload.Payload","type":"module"},{"doc":"Convert resolution errors to a mutation payload The build payload middleware will accept lists of AbsintheErrorPayload.ValidationMessage, atom, or string errors. Valid formats are: [%ValidationMessage{},%ValidationMessage{}] &quot;This is an error&quot; :error_atom [&quot;This is an error&quot;, &quot;This is another error&quot;]","ref":"AbsintheErrorPayload.Payload.html#build_payload/2","title":"AbsintheErrorPayload.Payload.build_payload/2","type":"function"},{"doc":"convert validation message field to camelCase format used by graphQL","ref":"AbsintheErrorPayload.Payload.html#convert_field_name/1","title":"AbsintheErrorPayload.Payload.convert_field_name/1","type":"function"},{"doc":"Direct converter from value to a Payload struct. This function will automatically transform an invalid changeset into validation errors. Changesets, error tuples and lists of AbsintheErrorPayload.ValidationMessage will be identified as errors and will generate an error payload. Error formats are: %Ecto.Changeset{valid?: false} %ValidationMessage{} {:error, %ValidationMessage{}} {:error, [%ValidationMessage{},%ValidationMessage{}]} {:error, &quot;This is an error&quot;} {:error, :error_atom} {:error, [&quot;This is an error&quot;, &quot;This is another error&quot;]} All other values will be converted to a success payload. or string errors. However, lists and strings will need to be wrapped in an :ok tuple or they will be seen as errors by graphql. An example use could look like: @doc &quot; Load a user matching an id Results are wrapped in a result monad as expected by absinthe. &quot; def get_user(%{id: id}, _resolution) do case UserContext.get_user(id) do nil -&gt; %ValidationMessage{field: :id, code: &quot;not found&quot;, message: &quot;does not exist&quot;}} user -&gt; user end |&gt; AbsintheErrorPayload.Payload.convert_to_payload() end","ref":"AbsintheErrorPayload.Payload.html#convert_to_payload/1","title":"AbsintheErrorPayload.Payload.convert_to_payload/1","type":"function"},{"doc":"Generates a mutation error payload. Examples iex&gt; error_payload(%ValidationMessage{code: &quot;required&quot;, field: &quot;name&quot;}) %Payload{successful: false, messages: [%ValidationMessage{code: &quot;required&quot;, field: &quot;name&quot;}]} iex&gt; error_payload([%ValidationMessage{code: &quot;required&quot;, field: &quot;name&quot;}]) %Payload{successful: false, messages: [%ValidationMessage{code: &quot;required&quot;, field: &quot;name&quot;}]} Usage If you prefer not to use the Payload.middleware, you can use this method in your resolvers instead. @doc &quot; updates an existing user. Results are wrapped in a result monad as expected by absinthe. &quot; def update(%{id: id, user: attrs}, _resolution) do case UserContext.get_user(id) do nil -&gt; {:ok, error_payload([%ValidationMessage{field: :id, code: &quot;not found&quot;, message: &quot;does not exist&quot;}])} user -&gt; do_update_user(user, attrs) end end defp do_update_user(user, attrs) do case UserContext.update_user(user, attrs) do {:ok, user} -&gt; {:ok, success_payload(user)} {:error, %Ecto.Changeset{} = changeset} -&gt; {:ok, error_payload(changeset)} end end","ref":"AbsintheErrorPayload.Payload.html#error_payload/1","title":"AbsintheErrorPayload.Payload.error_payload/1","type":"function"},{"doc":"Create a payload object definition Each object that can be mutated will need its own graphql response object in order to return typed responses. This is a helper method to generate a custom payload object Usage payload_object(:user_payload, :user) is the equivalent of object :user_payload do field :successful, non_null(:boolean), description: &quot;Indicates if the mutation completed successfully or not. &quot; field :messages, list_of(:validation_message), description: &quot;A list of failed validations. May be blank or null if mutation succeeded.&quot; field :result, :user, description: &quot;The object created/updated/deleted by the mutation&quot; end This method must be called after import_types AbsintheErrorPayload.MutationTypes or it will fail due to :validation_message not being defined.","ref":"AbsintheErrorPayload.Payload.html#payload_object/2","title":"AbsintheErrorPayload.Payload.payload_object/2","type":"macro"},{"doc":"Generates a success payload. Examples iex&gt; success_payload(%User{first_name: &quot;Stich&quot;, last_name: &quot;Pelekai&quot;, id: 626}) %Payload{successful: true, result: %User{first_name: &quot;Stich&quot;, last_name: &quot;Pelekai&quot;, id: 626}} Usage If you prefer not to use the build_payload/2 middleware, you can use this method in your resolvers instead. @doc &quot; Creates a new user Results are wrapped in a result monad as expected by absinthe. &quot; def create(%{user: attrs}, _resolution) do case UserContext.create_user(attrs) do {:ok, user} -&gt; {:ok, success_payload(user)} {:error, %Ecto.Changeset{} = changeset} -&gt; {:ok, error_payload(changeset)} end end","ref":"AbsintheErrorPayload.Payload.html#success_payload/1","title":"AbsintheErrorPayload.Payload.success_payload/1","type":"function"},{"doc":"This module defines assertions and helpers to use when testing graphql.","ref":"AbsintheErrorPayload.TestHelper.html","title":"AbsintheErrorPayload.TestHelper","type":"module"},{"doc":"Compares a expected list, map or struct to a graphql response. This function uses a field definition that specifies the expected field type of the data. This performs some simple transforms to properly compare values, including: camelCasing field names coverting all non-int values to strings, including converting false to &quot;false&quot; uppercasing enum field responses parsing date types as ISO Extended format strings Supported field types are: :string, :float, :integer, :enum, :date, :list, :boolean Example query = &quot;{ user(id: \\&quot;1\\&quot;) { firstName lastName age } } &quot; {:ok, %{data: data}} = evaluate_graphql(query) user_fields = %{first_name: :string, last_name: string, age: integer} expected = %User{first_name: &quot;Lilo&quot;, last_name: &quot;Pelekai&quot;, age: 6} %{&quot;user&quot; =&gt; result} = data assert_equivalent_graphql(expected, result, user_fields)","ref":"AbsintheErrorPayload.TestHelper.html#assert_equivalent_graphql/3","title":"AbsintheErrorPayload.TestHelper.assert_equivalent_graphql/3","type":"function"},{"doc":"Compares an expected list of validation errors to a successful mutation response, as generated by AbsintheErrorPayload.Payload.build_payload/2 Optionally pass a subset of fields to compare - by default all AbsintheErrorPayload.ValidationMessage fields are included, so you will need to use this parameter if you are returning fewer fields. Example user = insert(:user, %{first_name: &quot;Stitch&quot;}) query = &quot; mutation{ updateUser( id: \#{user.id} user: { age: 0 } ){ successful messages { field message code } result { id firstName age updatedAt } } } &quot; assert {:ok, %{data: data}} = evaluate_graphql(query) assert %{&quot;updateUser&quot; =&gt; payload} = data expected = %ValidationMessage{ code: :greater_than, field: :age, message: &quot;must be greater than 0&quot; } assert_mutation_failure([expected], payload, [:field, :message, :code])","ref":"AbsintheErrorPayload.TestHelper.html#assert_mutation_failure/3","title":"AbsintheErrorPayload.TestHelper.assert_mutation_failure/3","type":"function"},{"doc":"Compares an expected map to a successful mutation response, as generated by AbsintheErrorPayload.Payload.build_payload/2 Example query = &quot; mutation{ createUser( user: { age: 6 firstName: &quot;Lilo&quot; lastName: &quot;Pelekai&quot; } ){ successful messages { field message code } result { id age firstName lastName } } } &quot; assert {:ok, %{data: data}} = evaluate_graphql(query) assert %{&quot;createUser&quot; =&gt; payload} = data user_fields = %{first_name: :string, last_name: string, age: integer} expected = %User{first_name: &quot;Lilo&quot;, last_name: &quot;Pelekai&quot;, age: 6} assert_mutation_success(expected, payload, user_fields) assert %User{} = Repo.get(User, payload[&quot;result&quot;][&quot;id&quot;])","ref":"AbsintheErrorPayload.TestHelper.html#assert_mutation_success/3","title":"AbsintheErrorPayload.TestHelper.assert_mutation_success/3","type":"function"},{"doc":"compares ISO Extended formatted strings","ref":"AbsintheErrorPayload.TestHelper.html#assert_similar_times/2","title":"AbsintheErrorPayload.TestHelper.assert_similar_times/2","type":"function"},{"doc":"Returns a map with all keys and values set to strings, which is close to how the raw graphql result is returned. Numbers are always stringified as this function has no insight into the graphql schema. This is compensated for in assert_equivalent_graphql/3, which has context about expected data types. Associations are returned as &quot;association&quot; if not preloaded.","ref":"AbsintheErrorPayload.TestHelper.html#to_stringified_map/1","title":"AbsintheErrorPayload.TestHelper.to_stringified_map/1","type":"function"},{"doc":"Mapping of AbsintheErrorPayload.ValidationMessage fields used by assert_mutation_failure","ref":"AbsintheErrorPayload.TestHelper.html#validation_message_fields/0","title":"AbsintheErrorPayload.TestHelper.validation_message_fields/0","type":"function"},{"doc":"Subset of Mapping of AbsintheErrorPayload.ValidationMessage fields used by assert_mutation_failure","ref":"AbsintheErrorPayload.TestHelper.html#validation_message_fields/1","title":"AbsintheErrorPayload.TestHelper.validation_message_fields/1","type":"function"},{"doc":"Stores validation message information. Fields :field The input field that the error applies to. The field can be used to identify which field the error message should be displayed next to in the presentation layer. If there are multiple errors to display for a field, multiple validation messages will be in the result. This field may be nil in cases where an error cannot be applied to a specific field. :message A friendly error message, appropriate for display to the end user. The message is interpolated to include the appropriate variables. Example: &quot;Username must be at least 10 characters&quot; :template A template used to generate the error message, with placeholders for option substiution. Example: &quot;Username must be at least %{count} characters&quot; :code A unique error code for the type of validation that failed. This field must be provided. See AbsintheErrorPayload.ChangesetParser.to_code/1 for built in codes corresponding to most Ecto validations. :options A list of key value pair to be applied to a validation message template. The structure is a list of %{key: _, value: _} to be able to serialize to a GraphQL type :key Deprecated, use :field instead","ref":"AbsintheErrorPayload.ValidationMessage.html","title":"AbsintheErrorPayload.ValidationMessage","type":"module"},{"doc":"This contains absinthe objects used in mutation responses. To use, import into your Absinthe.Schema files with import_types AbsintheErrorPayload.ValidationMessageTypes Objects :validation_option holds a key value pair. These values are substitutions to be applied to a validation message template object :validation_option do field :key, non_null(:string), description: &quot;...&quot; field :value, non_null(:string), description: &quot;...&quot; end :validation_message contains all fields included in a AbsintheErrorPayload.ValidationMessage for maximum flexibility. This is possibly more information than you wish to supply - in that case, rather than importing this Module, you can create your own objects and use them. For example, if you only want to supply interpolated messages, the :template and :options fields are unnecessary. object :validation_message, description: &quot;...&quot; do field :field, :string, description: &quot;...&quot; field :message, :string, description: &quot;...&quot; field :code, non_null(:string), description: &quot;...&quot; field :template, :string, description: &quot;...&quot; field :options, list_of(:validation_option), description: &quot;...&quot; end Actual descriptions have been ommited for brevity - check the github repo to see them.","ref":"AbsintheErrorPayload.ValidationMessageTypes.html","title":"AbsintheErrorPayload.ValidationMessageTypes","type":"module"},{"doc":"Bridges the gap between Ecto and Absinthe GraphQL by listing validation messages in a mutation payload. The primary philosophy is that messages generated by invalid and/or unexpected user input are DATA, and should be returned as such. On the other hand, errors made in using an API - like querying a field that doesn’t exist -, are actually ERRORS and should be returned as errors. GraphQL fits perfectly here. Error are handled explicitly in the query and actual errors are treated as internal error on client side library.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Install by adding absinthe_error_payload to your list of dependencies in mix.exs: def deps do [ {:absinthe_error_payload, &quot;~&gt; 1.0&quot;} ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"The best place to find usage examples is by looking at the test cases at the AbsintheErrorPayload GitHub or the docs for AbsintheErrorPayload.Payload Here’s a quick summary of what AbsintheErrorPayload includes AbsintheErrorPayload.ValidationMessage structs/objects are created with all the information you’d normally be able to access through Ecto.Changeset.traverse_errors/2. AbsintheErrorPayload includes a schema definition to add ValidationMessages to your schema. AbsintheErrorPayload.Payload is middleware that takes your resolver output (either an updated object or a changeset with errors) and converts it into a AbsintheErrorPayload Mutation Response (aka Payload). Payloads have three fields successful - Indicates if the mutation completed successfully or not. Boolean. messages - a list of validation errors. Always empty on success result - the data object that was created/updated/deleted on success. Always nil when unsuccessful. Finally AbsintheErrorPayload.TestHelper has some helper methods that make it easier to write ExUnit tests against your schema.","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"This library has been forked from Kronky, renamed to AbsintheErrorPayload and published on hexpm. Kronky was not being updated and while it still worked for older versions, a more maintained release was requested by many users. Thank you Ethelo for the awesome library!","ref":"readme.html#hey-this-looks-like-kronky","title":"README - Hey, this looks like Kronky!","type":"extras"},{"doc":"AbsintheErrorPayload is © 2019 Mirego and may be freely distributed under the New BSD license. See the LICENSE.md file. As mentionned above, AbsintheErrorPayload is based on Kronky which is licensed under the MIT license. See the KRONKY_LICENSE.md file. The flask logo is based on this lovely icon by Danil Polshin, from The Noun Project. Used under a Creative Commons BY 3.0 license.","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"Mirego is a team of passionate people who believe that work is a place where you can innovate and have fun. We’re a team of talented people who imagine and build beautiful Web and mobile applications. We come together to share ideas and change the world. We also love open-source software and we try to give back to the community as much as we can.","ref":"readme.html#about-mirego","title":"README - About Mirego","type":"extras"}]